#define  IP_INIT_GLOBAL
#include "Nano1X2Series.h"
#include "IP_Init.h"

void SysClkInit(void)
{
  SYS_UnlockReg() ;                                        // ֻ HIRC=12MHz 32768
  CLK->PWRCTL  |= CLK_PWRCTL_DELY_EN | CLK_PWRCTL_HIRC_EN | CLK_PWRCTL_LXT_EN ;         
  CLK->CLKDIV0  = 5 ;                                      // HCLK 6ƵΪ 2MHz  
  CLK->CLKDIV1  = 0xB000 ;                                 // Timer1 12Ƶ 1M                   
  CLK->CLKSEL1  = CLK_CLKSEL1_TMR1_S_HIRC | CLK_CLKSEL1_TMR0_S_LXT ;               
  CLK->AHBCLK   = CLK_AHBCLK_SRAM_EN | CLK_AHBCLK_ISP_EN | CLK_AHBCLK_GPIO_EN ;
  CLK->APBCLK   = CLK_APBCLK_LCD_EN  | CLK_APBCLK_TMR1_EN | CLK_APBCLK_TMR0_EN ;
  while((CLK->CLKSTATUS & CLK_CLKSTATUS_HIRC_STB) == 0);
  CLK->PWRCTL  = CLK_PWRCTL_DELY_EN | CLK_PWRCTL_HIRC_EN | CLK_PWRCTL_LXT_EN ;   
  SYS_LockReg() ;                                              
}                         // ȴ32768ȶŵһʹ32768ʱӴ, Timer0ʼǰ
void Delayus(uint32_t Tim)                                 // 24λ, Լ16.77 
{
  uint32_t Tick = TIMER1->DR ;
  while(((TIMER1->DR - Tick)&0xFFFFFF) <= Tim) ;
}
//// Timer1, 1MHz , ͨöʱ ////////////////////////////////////////////////
void Timer1Init(void) 
{
  TIMER1->CTL    = TIMER_CONTINUOUS_MODE | TIMER_CTL_TMR_EN_Msk ; 
  TIMER1->PRECNT = 0 ;                                    
  TIMER1->IER    = 0 ;                                     // ж
}
void LCD_Init(void)
{               
  LCD->CTL     = LCD_FREQ_DIV128                           // LCDʱ128*4Ƶ=64Hz
               | LCD_MUX_ONE_FOURTH                        // 4-MUX
               | LCD_CTL_PDDISP_EN_Msk                     // ״̬, LCD ʾ
               | LCD_CTL_EN_Msk  ;                         // LCD ʹ

	LCD->DISPCTL = LCD_DISPCTL_Res_Sel_Msk                   // ڲ400K                    
               | LCD_DISPCTL_BV_SEL_Msk                    // R-Type
               | LCD_DISPCTL_IBRL_EN_Msk                   // ʹ
               | LCD_BIAS_THIRD ;                          // 1/3ƫѹ
      
  LCD->MEM_0 = 0x04020006 ;
  LCD->MEM_1 = 0x0400020D ;
  LCD->MEM_2 = 0x0404020F ;
  LCD->MEM_3 = 0x04040206 ;
  LCD->MEM_4 = 0x0006020B ;
}
//// Timer0, 32768Hz ڼ ///////////////////////////////////////////////////////////
void Timer0Init(void)
{
  TIMER0->CTL    = TIMER_PERIODIC_MODE | TIMER_CTL_WAKE_EN_Msk | TIMER_CTL_SW_RST_Msk ;   
  TIMER0->PRECNT = 0 ;                                     // Ƶ
  TIMER0->CMPR   = 32768*5 ;                               // ֵ
  TIMER0->ISR    = ~0 ;                                    // ־
  TIMER0->IER    = TIMER_IER_TMR_IE_Msk ;                  // ж
  NVIC_SetPriority(TMR0_IRQn, 2) ;   
  NVIC_EnableIRQ(TMR0_IRQn) ;                              
  Delayus(90) ;                                            //һʱӺ, дЧ
  TIMER0->CTL |= TIMER_CTL_TMR_EN_Msk ;                    //Ȼ/Ķָ
}
